//Variables
var api_url = "https://mobileapi.iemsy.irradiare.biz/";
var api_client = "com.irradiare.iemsy-app.1";
var session_token = null;
var plot_real_time_consumptions = null;
var watchID = null;
var gps_position = null;
var gps_default_position = {coords: { latitude: 38.700, longitude: -9.1833 }};
var gps_updates_cont = 0;
var temp_code = null;
var light_point = null;
var multiple_lp = false;
var i18n_options = {lng: getLanguage(),
    resGetPath: 'locales/__lng__-__ns__.json'};
var dev_id = null;
var displayed_warning = {gps: false, sensor: false};

//Inicialize Translations
i18n.init(i18n_options, function(t) {
    updatei18n();
});

//Inicialize GPS Position
$(document).ready(function() {
    //Foi alterado pois não vale a pena ter um serviço a actualizar sempre
    //a localização. Vai se buscar apenas a actual localizaçao.
    // watchID = navigator.geolocation.watchPosition(onSuccess, onError);
    //getGpsPosition();
});

function getLanguage(){
    var lang = window.localStorage.getItem('language');
    if (lang == null || lang.length <0){
        setLanguage("en");
    }
    return window.localStorage.getItem('language');
}

function setLanguage(lng){
    window.localStorage.setItem('language', lng);
}

function updatei18n(){
    $("#Home").i18n();
    $("#Login").i18n();
    $("#CodeGen").i18n();
    $("#RealTimeConsumptions").i18n();
    $("#LightPointsMenu").i18n();
    $("#NewLightPoint").i18n();
    $("#NewMultLightPoints").i18n();
    $("#SettingsMenu").i18n();
}

//ClearSession to delete
function clearSession() {
    window.localStorage.removeItem('session_token');
    checkSession();
}

//Get options for RealTimeConsumptions
pageShow('#RealTimeConsumptions', function(){
    checkSession();
    datepick();
    getSensors();
}, true);

//Get options for NewLightPoint
//this call is async on gpsposition
pageShow('#NewLightPoint', function(){
    jQuery("input[type=text]").val('');
    refreshLightPointCoord();
}, false);

//Get options for LightPointsMenu
pageShow('#LightPointsMenu', function() {
    light_point = null;
    multiple_lp = false;
}, false);

pageShow('#SettingsMenu', function(){
    jQuery("#language").val(getLanguage());
    jQuery("#language").selectmenu("refresh", true);
    jQuery('#dev_id').text(dev_id);
}, true);

//Check session when all pages show for the first time
//except home where check everytime page show
pageShow("pageshow", '#Home', function() {
    checkSession();
});
jQuery(document).on("pageinit", '#RealTimeConsumptions', function() {
    checkSession();
});
jQuery(document).on("pageinit", '#LightPointsMenu', function() {
    checkSession();
});
jQuery(document).on("pageinit", '#NewLightPoint', function() {
    checkSession();
    jQuery('#lp_form #fk_tbl_transformation_station').change(function() {
        getCircuits();
    });
});


//Session and login functions
function checkLogin() {
    //startLoading();
    email = jQuery('#login_email').val();
    password = jQuery('#login_password').val();
    credentials = Base64.encode(email+':'+password);

    jQuery.ajax({
        url: api_url+'login',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Authorization": 'Basic '+credentials,
            "X-IEMSY-Client": api_client
        },
        success: setCredentials,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setCredentials(httpObj.responseJSON);
            } else {
                window.plugins.toast.showLongCenter(httpObj.statusText);
            }
        }
    });
    //stopLoading();
}

function setCredentials(response) {
    window.localStorage.setItem('session_token', response['X-IEMSY-Token']);
    jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
}


function checkSession() {
    //startLoading();
    session_token = window.localStorage.getItem('session_token');
    if(session_token == null || session_token.length <= 0) {
        jQuery.mobile.pageContainer.pagecontainer("change", "login.html");
    }
    //stopLoading();
}

//Handle LightPointMenu Navigation
function goToLightPoint() {
    multiple_lp = false;
    jQuery.mobile.pageContainer.pagecontainer("change", "newltpoint.html", {transition: "slide"});
}

function goToMultLightPoint() {
    multiple_lp = true;
    jQuery.mobile.pageContainer.pagecontainer("change", "newmultiltpoint.html", {transition: "slide"});
}

function goToSettingsMenu(){
    jQuery.mobile.pageContainer.pagecontainer("change", "settings.html", {transition: "flow"});
}
function goToHome(){
    jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
}

//Loading Widget
function startLoading() {
    jQuery.mobile.loading("show", {
        textVisible: true
    });
}

function stopLoading() {
    jQuery.mobile.loading("hide");
}

function pageShow(page, params, loading){
    jQuery(document).on("pageshow", page, function() {
        if (loading == true){
            startLoading();
            setTimeout(function(){
                params();
                stopLoading();
            }, 20);
        } else {
            params();
        }
    });
}

function getGpsPosition(Callbackfunction) {
    function onSuccess(position) {
        gps_position = position;
        Callbackfunction(gps_position);
    }

    function onError(error) {
        if(error.code == 3){
            window.plugins.toast.showLongCenter(i18n.t('Retrieving Position Error'));

            //alert($.t('Retrieving Position Error'));
        } else {
            alert('code: ' + error.code + '\n' +
                    'message: ' + error.message + '\n');
        }
        gps_position = gps_default_position;
        Callbackfunction(gps_position);
    }

    startLoading();
    navigator.geolocation.getCurrentPosition(onSuccess, onError, { timeout: 10000 });
}
