function setLightPointFormOptions(gps_position) {
    //refreshLightPointCoord();
    latitude_y = gps_position.coords.latitude;
    longitude_x = gps_position.coords.longitude;
    jQuery('#lp_form #latitude_y').val(latitude_y);
    jQuery('#lp_form #longitude_x').val(longitude_x);
    getTransformationStations();
    getCircuits();
    getRoadTypes();
    getFixtureTypes();
    getLampTypes();
    getBallastTypes();
    getDiffuserTypes();
    getSensorTypes();
    getFixationTypes();
    getLightFromSensor();
    stopLoading();
}

function getTransformationStations() {
    //startLoading();
    //getGpsPosition();
    jQuery.ajax({
        url: api_url+'transformation-station/'+gps_position.coords.latitude+'/'+gps_position.coords.longitude,
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setTransformationStations,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setTransformationStations(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function getCircuits() {
    //startLoading();
    jQuery.ajax({
        url: api_url+'transformation-station/'+jQuery("#lp_form #fk_tbl_transformation_station").val()+'/circuit',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setCircuits,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setCircuits(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function getRoadTypes() {
    //startLoading();
    jQuery.ajax({
        url: api_url+'road-type',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setRoadTypes,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setRoadTypes(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function getFixtureTypes() {
    //startLoading();
    jQuery.ajax({
        url: api_url+'fixture-type',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setFixtureTypes,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setFixtureTypes(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function getLampTypes() {
    //startLoading();
    jQuery.ajax({
        url: api_url+'lamp-type',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setLampTypes,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setLampTypes(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function getBallastTypes() {
    //startLoading();
    jQuery.ajax({
        url: api_url+'ballast-type',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setBallastTypes,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setBallastTypes(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function getDiffuserTypes() {
    //startLoading();
    jQuery.ajax({
        url: api_url+'diffuser-type',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setDiffuserTypes,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setDiffuserTypes(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function getSensorTypes() {
    //startLoading();
    jQuery.ajax({
        url: api_url+'sensor-type',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setSensorTypes,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                //console.log(httpObj);
                setSensorTypes(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function getFixationTypes() {
    //startLoading();
    jQuery.ajax({
        url: api_url+'fixation-type',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setFixationTypes,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setFixationTypes(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
    //stopLoading();
}

function setTransformationStations(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_transformation_station');
}

function setCircuits(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_transformation_station_circuit');
}

function setRoadTypes(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_road_type');
}

function setFixtureTypes(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_fixture_type');
}

function setLampTypes(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_lamp_type');
}

function setBallastTypes(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_ballast_type');
}

function setDiffuserTypes(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_diffuser_type');
}

function setSensorTypes(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_sensor_type');
}

function setFixationTypes(response) {
    printLightPointOptions(response['objects'], 'object_id', 'name', 'fk_tbl_fixation_type');
}

function setLampPower(lux){
        jQuery('#lp_form #light_point_illuminance').val(lux);
}

//Gets and Sets For Light Point Form Options
function refreshLightPointCoord() {
    getGpsPosition(setLightPointFormOptions);
}

function printLightPointOptions(objects, object_id, object_text, form_list_id) {
    options = '';
    jQuery.each(objects, function() {
        options += '<option value="' + this[object_id] + '">' + this[object_text] + '</option>';
    });
    jQuery('#lp_form #' + form_list_id).empty();
    jQuery('#lp_form #' + form_list_id).html(options);
    jQuery('#lp_form #' + form_list_id).selectmenu('refresh', true);
}

//Save Light Point
function prepareLightPointObject() {
    light_point = {
        "fk_tbl_transformation_station_circuit": jQuery('#lp_form #fk_tbl_transformation_station_circuit').val(),
        "latitude_y": jQuery('#lp_form #latitude_y').val(),
        "longitude_x": jQuery('#lp_form #longitude_x').val(),
        "lp_name": jQuery('#lp_form #lp_name').val(),
        "height": jQuery('#lp_form #height').val(),
        "fk_tbl_road_type": jQuery('#lp_form #fk_tbl_road_type').val(),
        "fk_tbl_fixture_type": jQuery('#lp_form #fk_tbl_fixture_type').val(),
        "fk_tbl_lamp_type": jQuery('#lp_form #fk_tbl_lamp_type').val(),
        "fk_tbl_ballast_type": jQuery('#lp_form #fk_tbl_ballast_type').val(),
        "fk_tbl_diffuser_type": jQuery('#lp_form #fk_tbl_diffuser_type').val(),
        "fk_tbl_sensor_type": jQuery('#lp_form #fk_tbl_sensor_type').val(),
        "fk_tbl_fixation_type": jQuery('#lp_form #fk_tbl_fixation_type').val(),
        "light_point_illuminance": jQuery('#lp_form #light_point_illuminance').val(),
        is_multiple: false,
        "device_id": dev_id
    }
    single_light_point = light_point;
    saveLightPoint(single_light_point);
    if(multiple_lp === true) {
      jQuery.mobile.pageContainer.pagecontainer("change", "newmultiltpoint.html", {transition: "slide"});
    } else {
      jQuery.mobile.pageContainer.pagecontainer("change", "newltpoint.html", {transition: "slide", reverse: true});
    }
}

function saveLightPoint(single_light_point) {
    startLoading();
    //getGpsPosition();
    if(multiple_lp === true && single_light_point == null) {
        light_point.latitude_y = gps_position.coords.latitude;
        light_point.longitude_x = gps_position.coords.longitude;
        light_point.is_multiple = true;
    }
    jQuery.ajax({
        url: api_url+'light-point',
        type: "POST",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        data: JSON.stringify(light_point),
        contentType: "application/json",
        success: function(httpObj, textStatus){
            alert($.t('Inserted Light Point'));
        },
        error: function(httpObj, textStatus){
            //console.log(httpObj.status);
            if(httpObj.status == 201) {
                alert($.t('Inserted Light Point'));
            } else {
                alert($.t('Query Failed'));
                jQuery.mobile.pageContainer.pagecontainer("change", "newltpoint.html", {transition: "flow"});
            }
        }
    });
    stopLoading();
}


function getLightFromSensor(){
    function onSuccess(state) {
        light.disableSensor();
        setLampPower(state);
        if (displayed_warning['sensor'] != true){
            window.plugins.toast.showLongCenter(i18n.t('Sensor Warning'));
            displayed_warning['sensor'] = true;
        }
    }
    light = cordova.require("cordova-plugin-lightSensor.light");
    light.enableSensor();
    light.getLightState(onSuccess);
}


//Prevent page refresh on submit
jQuery(document).on('submit', '#lp_form', function(e) {
    e.preventDefault();
    //Form validation
    jQuery.validate({
        form: '#lp_form',
        onSuccess: function() {
            prepareLightPointObject();
        }
    });
});
