function datepick(){
  jQuery("#fromdate").val(moment().add(-1, 'days').format('YYYY-MM-DD'));
  jQuery("#todate").val(moment().format('YYYY-MM-DD'));
}

//Get and set Sensors list
function getSensors() {
  getGpsPosition(function(gps_position){
    jQuery.ajax({
        url: api_url+'sensor',
        type: "GET",
        dataType: "json",
        async: false,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        data: {
          'latitude_y': gps_position.coords.latitude,
          'longitude_x': gps_position.coords.longitude
        },
        success: setSensors,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setSensors(httpObj.responseJSON);
            } else {
                alert(httpObj.responseJSON['message']);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
  });
    

}

function setSensors(response) {
    jQuery('#select-sensor').empty();
    options = '';
    jQuery.each(response['objects'], function() {
        options += '<option data-apikey="'+this['apikey']+'" value="'+ this['datatoken'] +'">' + this['name'] + '</option>';
    });
    jQuery('#select-sensor').html(options);
    jQuery('#select-sensor').selectmenu('refresh', true);
    getPlotData();
}


//Get and set Plot Data
function getPlotData() {
    var now = new Date();
    var minutesToUtc = now.getTimezoneOffset();
    var fromDate = new Date(jQuery('#fromdate').val()).toISOString();
    var toDate = new Date(jQuery('#todate').val()).toISOString();
    var datatoken = jQuery("#select-sensor").val();
    var apikey = jQuery("#select-sensor :selected").data('apikey');
    var timeframe = jQuery("#timeframe").val();
    jQuery.ajax({
        url: api_url+'livedata/'+timeframe+'/'+apikey+'/'+datatoken+'/'+fromDate+'/'+toDate+'/'+minutesToUtc,
        type: "GET",
        dataType: "json",
        async: true,
        headers: {
            "X-IEMSY-Token": session_token,
            "X-IEMSY-Client": api_client
        },
        success: setPlotData,
        error: function(httpObj, textStatus){
            if(httpObj.status == 200) {
                setPlotData(httpObj.responseJSON);
            } else {
                window.plugins.toast.showLongBottom(httpObj.statusText);
                jQuery.mobile.pageContainer.pagecontainer("change", "index.html", {transition: "flow"});
            }
        }
    });
}

function setPlotData(response) {
    var graphX = ['x'];
    var graphY = ['Consumptions'];
    var timeframe = jQuery("#timeframe").val();
    jQuery.each(response.objects, function() {
        var date = moment.tz(this.iso_utc_time_start, "UTC");
        //date.utcOffset(moment().format("Z"));
        graphX.push(date);
        graphY.push(this.data_value);
    });

    var realtimeconsumptions_chart = c3.generate({
        bindto: '#realtimeconsumptions_chart',
        data: {
            x: 'x',
            columns: [
                graphX,
                graphY
            ]
        },
        axis: {
            x: {
                type: 'timeseries',
                tick: {
                  fit: true,
                  count: 5,
                  format: getTimeframeFormat(timeframe)
                }
            }
        }
    });
}

function getTimeframeFormat(args) {
    if (args == 'daily') {
        return '%m-%d';
    }else if (args == 'hourly') {
        return '%H:%M';
    }else if (args == 'monthly') {
        return '%Y-%m-%d';
    }else if (args == 'quarterly') {
        return '%H:%M:%S';
    }else if (args == 'minute') {
        return '%H:%M:%S';
    }else if (args == 'yearly') {
        return '%Y-%m';
    };
}